#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <sipp.h>
#include <primitives.h>
extern char *optarg;

main(argc,argv)
     int argc;
     char **argv;
{
double feld[4000][3];
char st[80],*dum;
char mylinebuffer[80];
double xx,yy,zz;
double xmax,xmin,ymax,ymin,zmax,zmin;
double xmid,ymid,zmid,xsize,ysize,zsize;
int i,ii=0,feldgroesse,zeile,spalte;
FILE *image_fd;
int ru;
Surface * mysurface;
Object * myobjekt;

int mode;
int c;
int size;

sipp_init();
mode=PHONG;
size=256;

while ((c=getopt(argc,argv,"pgfls:")) !=EOF)
  {
    switch (c) {
          case 'p':
           mode = PHONG;
            break;

          case 'g':
            mode = GOURAUD;
            break;

          case 'f':
            mode = FLAT;
            break;

          case 'l':
            mode = LINE;
            break;

          case 's':
            size = atoi(optarg);
            break;
	 }
  }

for(;0==feof(stdin);)
 {
  fgets(st,80,stdin);  
  if (st[0]=='i') 
   {
     strcpy(mylinebuffer,(char *)strtok(st,"=")); 
     if (dum=strtok(NULL,"y="))
       {
     xx=strtod((char *)dum,(char **)NULL);
     yy=strtod((char *)strtok(NULL,"z="),(char **)NULL);
     zz=strtod((char *)strtok(NULL,"= "),(char **)NULL);
     fflush(stdout);
     feld[ii][0]=xx;
     feld[ii][1]=yy;
     feld[ii][2]=zz;
     ii++;                /*       zaehlt die Anzahl der Koordinaten    */
       }
    }
 }


                   /*         find the max and min values              */
xmax=xmin=feld[0][0];
ymax=ymin=feld[0][1];
zmax=zmin=feld[0][2];
for(i=1;i<ii;i++)
  {
    if(feld[i][0]<xmin) xmin=feld[i][0];
    if(feld[i][1]<ymin) ymin=feld[i][1];
    if(feld[i][2]<zmin) zmin=feld[i][2];
    if(feld[i][0]>xmax) xmax=feld[i][0];
    if(feld[i][1]>ymax) ymax=feld[i][1];
    if(feld[i][2]>zmax) zmax=feld[i][2];
  }
xmid=(xmin+xmax)/2;
ymid=(ymin+ymax)/2;
zmid=(zmin+zmax)/2;
xsize=20/(xmax-xmin);
ysize=20/(ymax-ymin);
zsize=20/(zmax-zmin);


                  /*      move and resize the thing           */
for(i=0;i<ii;i++)
  {
    feld[i][0]=(feld[i][0]-xmid)*xsize;
    feld[i][1]=(feld[i][1]-ymid)*ysize;
    feld[i][2]=(feld[i][2]-zmid)*zsize;
  }

lightsource_create(1.0,1.0,1.0, 1.0,1.0,1.0, LIGHT_DIRECTION);
image_fd=fopen("/tmp/out.ppm","w");
sipp_show_backfaces(TRUE);

feldgroesse=(int)(sqrt((double)ii/2));
printf("Koordinatenanzahl=%i,Feld ist %i*%i\n",ii,feldgroesse,feldgroesse);
for (zeile=1;zeile<=feldgroesse-1;zeile++)
  {
   for (spalte=1;spalte<=feldgroesse-1;spalte++)
     {
       ru=zeile*feldgroesse+spalte;
       vertex_push(feld[ru][0],feld[ru][1],feld[ru][2]);
       vertex_push(feld[ru-1][0],feld[ru-1][1],feld[ru-1][2]);
       vertex_push(feld[ru-1-feldgroesse][0],feld[ru-1-feldgroesse][1],feld[ru-1-feldgroesse][2]);
       vertex_push(feld[ru][0],feld[ru][1],feld[ru][2]);
       polygon_push();
       vertex_push(feld[ru][0],feld[ru][1],feld[ru][2]);
       vertex_push(feld[ru-feldgroesse][0],feld[ru-feldgroesse][1],feld[ru-feldgroesse][2]);
       vertex_push(feld[ru-1-feldgroesse][0],feld[ru-1-feldgroesse][1],feld[ru-1-feldgroesse][2]);
       vertex_push(feld[ru][0],feld[ru][1],feld[ru][2]);
       polygon_push();
     }  
 }
mysurface= surface_basic_create(0.4 ,0.5,0.5,0.8 ,0.6 ,0.1 ,1.0,1.0,1.0);
myobjekt=object_create();
object_add_surface(myobjekt,mysurface);
object_add_subobj(sipp_world,myobjekt);
camera_params(sipp_camera,20.0,100.0,100.0 ,0.0,0.0,0.0 ,0.0,0.0,1.0 ,0.1);
printf("Rendering, wait...");
fflush(stdout);
render_image_file(size,size,image_fd,mode,1);
return(100);
}









